# Contributing to the Recursive Project

## Types of contributions

**Issues** 

If you find something that’s not working as you expect, please file an issue

**Documentation improvements** 

If you find a typo or something that seems out of date in the Readme, etc, please feel free to file a Pull Request with your suggested change(s)

**Type design fixes/changes**

Type design is a bit of a special case for open source projects, because type tends to benefit from a central, strong creative & technical direction. There are probably exceptions to this, but Recursive is not really one of them.

That said, type design contributions are very highly valued here, but they require a connection and personal communication to go well.

Have an idea for something that you think would be worth changing in the design? Cool! You have two good options:

1. File an issue to point out the design problem, and mention your idea/request to fix it, if you have one. @ArrowType will try to comment on the issue fairly promptly, and the proposed solution can be discussed before a course of action is decided.
2. Alternatively, this project is [OFL-licensed](OFL.txt), so you are welcome to fork the repo and make whatever changes you like, so long as you keep the same license and respect its provisions. In this scenario, please be sure to change the font family name to avoid user confusion.

## Contribution requirements

Things that will make contributions work well:

1. Activate the [ufoNormalizer](https://github.com/unified-font-object/ufoNormalizer) to use in RoboFont. This will minimize noise in Git commits by keeping the UFO internal code formatting similar.
2. Work in a [feature branch](https://guides.github.com/introduction/flow/) named for the feature/fixes you are working on, e.g. `powerline-glyphs`.

(More suggestions will be added over time.)